<template>
  <div>
    <v-row>
      <v-col md="4" cols="12" class="pb-0 py-md-5">
        <div>FECHA INICIO:</div>
        <date-picker class="px-0" key="1" :change-function="(date) => $emit('searchAvailability', {date, type: 'start'})" />
      </v-col>
      <v-col md="4" cols="12" class="py-0 py-md-5">
        <div>FECHA FIN:</div>
        <date-picker class="px-0" key="2" :change-function="(date) => $emit('searchAvailability', {date, type: 'end'})" />
      </v-col>
      <v-col md="4" cols="12" class="py-0 py-md-5">
        <div>DURACIÓN PROMEDIO:</div>
        <v-col class="font-weight-medium px-0">
          <div class="py-0 py-md-4">
          <v-icon>mdi-clock-outline</v-icon> 30 minutos
          </div>
        </v-col>
      </v-col>
    </v-row>
        <div class="text-uppercase my-4" v-if="specialistsLength" v-html="specialistNumber(specialistsAvailable.length)"/>
        <v-divider></v-divider>
    <div
      v-for="(day, index) in specialistsAvailable"
      :key="index"
      class="my-5"
    >
      <div v-if="day.specialists.length>0">
        <v-row no-gutters justify="start">
          <v-col md="4">
            <h2 class="subtitle-1">
              {{ formatDate(day.date) }}
            </h2>
          </v-col>
        </v-row>

        <div v-for="(specialist, indexSpecialist) in day.specialists" :key="indexSpecialist">
          <availability-specialist-card
            :name-specialist="specialist.user.name"
            :father-specialist="specialist.user.fatherLastname"
            :mother-specialist="specialist.user.motherLastname"
            :image-specialist="specialist.user.profileImageUrl"
            :availability-specialist="specialist.availabilities"
            :id-specialist="specialist.user.uuid"
            :pos-specialist="indexSpecialist"
            :index-availavility="indexAvailavility"
            :selected="specialistSelected"
            :id-availability="availability"
            :index-selected="indexSelected"
            :index="index"
            @getIndexAvailability="(event) => { $emit('getPosAvailability', event) }"
            @getIdAvailability="(event) => { $emit('getHour', event) }"
            @getUuidSpecialist="(event) => { $emit('getUuidSpecialist', event) }"
            @getIndexSpecialist="(event, indexA) => { $emit('getPosSpecialist', index, event, indexA) }"
            @continue="$emit('changeStep')"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import AvailabilitySpecialistCard from '~/components/Cards/AvailabilitySpecialistCard.vue';
import DatePicker from '~/components/DatePickers/DatePicker.vue';
export default {
  components: {
    'availability-specialist-card': AvailabilitySpecialistCard,
    'date-picker': DatePicker,
  },
  props: {
    specialistsAvailable: {
      type: Array,
      default: () => { return []; },
    },
    selectedIdSchedule: {
      type: Number,
      default: 0,
    },
    indexAvailavility: {
      type: Number,
      default: -1,
    },
    specialistSelected: {
      type: Object,
      default: () => { return {}; },
    },
    availability: {
      type: Number,
      default: 0,
    },
    indexSelected: {
      type: Number,
      default: 0,
    },
  },
  computed: {
    specialistsLength() {
      try {
        const amount = this.specialistsAvailable[0].specialists.length > 0
        return amount
      } catch {
        return 0
      }
    }
  },
  methods: {
    formatDate(date) {
      if (!date) { return null; }

      const [year, month, day] = date.split('-');
      const months = ['enero', 'febrero', 'marzo', 'abril', 'mayo', 'junio', 'julio', 'agosto',
        'setiembre', 'octubre', 'noviembre', 'diciembre'];
      return `${day} de ${months[month - 1]} del ${year}`;
    },
    specialistNumber(amount) {
      console.log(this.specialistsAvailable)
      const html = `<span class="font-weight-medium">tenemos ${ amount }</span> `
      const sufix = amount === 1 ? 'especialista disponible' : 'especialistas disponibles'
      return html.concat(sufix)
    }
  },
};
</script>
<style scoped>
.subtitle-1 {
  font-weight: 500;
  color: grey;
  margin-top: 10px;
}
</style>
